// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 21-Feb-1998
// 
#include <LINK/basic/Point.h>
Point
Point::max(const Point& p) const
{
    Point max = p;
    if (x > max.x) max.x = x;
    if (y > max.y) max.y = y;
    return max;
}
Point
Point::min(const Point& p) const
{
    Point min = p;
    if (x < min.x) min.x = x;
    if (y < min.y) min.y = y;
    return min;
}
Bool
Point::withinEpsilon(const Point& p, int eps) const
{
    if (x > (p.x - eps) && x < (p.x + eps) &&
	y > (p.y - eps) && y < (p.y + eps))
	return TRUE;
    else
	return FALSE;
}
Point
operator*(const Point& p, int i)
{
    return Point(i*p.x, i*p.y);
}
Point
operator*(int i, const Point& p)
{
    return Point(i*p.x, i*p.y);
}
Point
operator*(const Point& p, float f)
{
    return Point((short) (f*p.x), (short) (f*p.y));
}
Point
operator*(float f, const Point& p)
{
    return Point((short) (f*p.x), (short) (f*p.y));
}
ostream&
operator<<(ostream& stream, Point p)
{
    stream << "(" << p.x << "," << p.y << ")";
    return stream;
}
